%% testing observability

tol = 1e-4;

incr=expected_halflife/number_of_samples;
TT=(0:incr:expected_halflife*3);
DI=max(TT);
dn=zeros(size(DI))+max(TT);

THETA=BETAI;
F_return=p_model(TT, THETA, D, dn, DI, count_mod, idose);
for jjz=1:IDMAX
    if jjz==1
        F1=F_return(jjz,:);
    elseif jjz==2
        F2=F_return(jjz,:);
    end
end

for kl=1:mr+1
    if kl==1
        F_pred=F1;
    end
    if kl==2
        F_pred=F2;
    end
    if kl==3
        F_pred=F3;
    end

    for jk=1:length(BETAI)
        %lower
        THETA=BETAI;
        THETA(jk)=THETA(jk)*0.5;
        F_return=p_model(TT, THETA, D, dn, DI, count_mod, idose);
        for jjz=1:IDMAX
            if jjz==1
                F1=F_return(jjz,:);
            elseif jjz==2
                F2=F_return(jjz,:);
            end
        end
        if kl==1
            Fpred_lower(jk,:)=F1;
        end
        if kl==2
            Fpred_lower(jk,:)=F2;
        end
        if kl==3
            Fpred_lower(jk,:)=F3;
        end

        %upper
        THETA=BETAI;
        THETA(jk)=THETA(jk)*2;
        F_return=p_model(TT, THETA, D, dn, DI, count_mod, idose);
        for jjz=1:IDMAX
            if jjz==1
                F1=F_return(jjz,:);
            elseif jjz==2
                F2=F_return(jjz,:);
            end
        end
        if kl==1
            Fpred_upper(jk,:)=F1;
        end
        if kl==2
            Fpred_upper(jk,:)=F2;
        end
        if kl==3
            Fpred_upper(jk,:)=F3;
        end
    end

    for jk=1:length(BETAI)
        max_diff(jk,1)=max(abs(Fpred_upper(jk,:) - Fpred_lower(jk,:)));
    end

    a=find(max_diff<tol);

    if kl==1
        display('**** Observability analysis ****')
        display(' ')
        display('Response 1')
        display(' ')
    else
        display(' ')
        display ('Response 2')
        display(' ')
    end 

    if isempty(a) ==1
        display(['All parameters are observable for response ',num2str(kl)])
    else
        display(['Parameters ',num2str(a'),' are not observable for response',num2str(kl)])
    end
    display(' ')

    for jk=1:length(BETAI)
        max_rel_diff(jk,1)=max(abs((Fpred_upper(jk,:) - Fpred_lower(jk,:))./F_pred));
    end

    a=find(max_rel_diff<(cv_assay*1.95));

%     if isempty(a) ==1
%         display(['All parameters are practically observable for response ',num2str(kl)])
%     else
%         display(['Parameters ',num2str(a'),'  may not be practically observable for response ',num2str(kl) ])
%     end
    display(' ')

end 
